#pragma once

#include "command.h"
class IGlobalAICallback;

#define GLOBALAI_INTERFACE_VERSION 1

#include "float3.h"

class IGlobalAI
{
public:
	virtual void InitAI(IGlobalAICallback* callback, int team)=0;
	// unit id of the commander.  let's the AI start action
	virtual void Start(int commanderid);

	virtual void UnitCreated(int unit)=0;
	virtual void UnitDestroyed(int unit)=0;

	// this is handled as an installed callback on a specific "spotter" unit
	// *hint* i'd probably use this on a peeper, send it into an enemy base, and recon all hits
	// to store in memory
	virtual void EnemyEnterLOS(int spotter)=0;

	// not sure how this will be implemented yet...
	// im thinking along the lines of allies giving eachother commands or
	// notifications of their actions to coordinate attacks
	virtual void GiveMessage()=0;
	
	// i guess this will be called every frame, to let the AI do as it will
	virtual void Update()=0;
};
